"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
module.exports = (rule, context) => __awaiter(this, void 0, void 0, function* () {
    const { system, strings } = context;
    try {
        // execute the command
        const exec = yield system.spawn(rule.command, { shell: true });
        const { stdout = '' } = exec;
        // clean it up
        const output = strings.trimEnd(stdout.toString());
        // look for matches
        let isMatch = false;
        const match = rule.match && new RegExp(rule.match);
        if (match) {
            isMatch = match.test(output);
        }
        return isMatch;
    }
    catch (e) {
        return false;
    }
});
//# sourceMappingURL=checkShell.js.map