"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const types_1 = require("../types");
const envinfo_1 = require("envinfo");
const callsite = require('callsite');
const path = require('path');
// Adding our goodies to the context
module.exports = (context) => {
    const { filesystem } = context;
    context.solidarity = types_1.solidarity;
    // place for plugins
    context._pluginsList = [];
    // the add plugin function
    context.addPlugin = (pluginConfig) => {
        // I'll fiinnnnd youuuu... calling function
        const stack = callsite();
        const requester = stack[1].getFileName();
        const templateDirPotential = path.join(path.dirname(requester), '../templates/');
        // Don't store directories that aren't there!
        const templateDirectory = filesystem.exists(templateDirPotential) ? templateDirPotential : null;
        context._pluginsList.push(Object.assign({ templateDirectory }, pluginConfig));
    };
    // Add helpers
    context.envInfo = envinfo_1.helpers;
    // Flavored separator
    context.printSeparator = () => context.print.info(context.print.colors.america('-----------------------------------------------------------------------------------'));
};
//# sourceMappingURL=solidarity-extension.js.map